
/* EJS wrapper functions auto-generated by pidl */
#include "includes.h"
#include "librpc/rpc/dcerpc.h"
#include "lib/appweb/ejs/ejs.h"
#include "scripting/ejs/ejsrpc.h"
#include "scripting/ejs/smbcalls.h"
#include "librpc/gen_ndr/ndr_misc_ejs.h"
#include "librpc/gen_ndr/ndr_sasl_helpers.h"
#include "librpc/gen_ndr/ndr_sasl_helpers_ejs.h"


_PUBLIC_ NTSTATUS ejs_push_saslauthdRequest(struct ejs_rpc *ejs, struct MprVar *v, const char *name, const struct saslauthdRequest *r)
{
	NDR_CHECK(ejs_push_struct_start(ejs, &v, name));
	NDR_CHECK(ejs_push_uint16(ejs, v, "authid_length", &r->authid_length));
	NDR_CHECK(ejs_push_string(ejs, v, "authid", r->authid));
	NDR_CHECK(ejs_push_uint16(ejs, v, "passwd_length", &r->passwd_length));
	ejs_push_array_uint8(ejs, v, "passwd", r->passwd, r->passwd_length);
	NDR_CHECK(ejs_push_uint16(ejs, v, "service_length", &r->service_length));
	NDR_CHECK(ejs_push_string(ejs, v, "service", r->service));
	NDR_CHECK(ejs_push_uint16(ejs, v, "realm_length", &r->realm_length));
	NDR_CHECK(ejs_push_string(ejs, v, "realm", r->realm));
	return NT_STATUS_OK;
}

_PUBLIC_ NTSTATUS ejs_pull_saslauthdRequest(struct ejs_rpc *ejs, struct MprVar *v, const char *name, struct saslauthdRequest *r)
{
	NDR_CHECK(ejs_pull_struct_start(ejs, &v, name));
	NDR_CHECK(ejs_pull_string(ejs, v, "authid", &r->authid));
	NDR_CHECK(ejs_pull_uint16(ejs, v, "passwd_length", &r->passwd_length));
	EJS_ALLOC_N(ejs, r->passwd, r->passwd_length);
	ejs_pull_array_uint8(ejs, v, "passwd", r->passwd, r->passwd_length);
	NDR_CHECK(ejs_pull_string(ejs, v, "service", &r->service));
	NDR_CHECK(ejs_pull_string(ejs, v, "realm", &r->realm));
	return NT_STATUS_OK;
}


static NTSTATUS ejs_pull_decode_saslauthd(struct ejs_rpc *ejs, struct MprVar *v, struct decode_saslauthd *r)
{
	NDR_CHECK(ejs_pull_struct_start(ejs, &v, "input"));
	NDR_CHECK(ejs_pull_saslauthdRequest(ejs, v, "req", &r->in.req));
	return NT_STATUS_OK;
}


static NTSTATUS ejs_push_decode_saslauthd(struct ejs_rpc *ejs, struct MprVar *v, const struct decode_saslauthd *r)
{
	NDR_CHECK(ejs_push_struct_start(ejs, &v, "output"));
	return NT_STATUS_OK;
}

static int ejs_decode_saslauthd(int eid, int argc, struct MprVar **argv)
{
	return ejs_rpc_call(eid, argc, argv, &dcerpc_table_sasl_helpers, DCERPC_DECODE_SASLAUTHD, (ejs_pull_function_t)ejs_pull_decode_saslauthd, (ejs_push_function_t)ejs_push_decode_saslauthd);
}

static int ejs_sasl_helpers_init(int eid, int argc, struct MprVar **argv)
{
	struct MprVar *obj = mprInitObject(eid, "sasl_helpers", argc, argv);
	mprSetCFunction(obj, "decode_saslauthd", ejs_decode_saslauthd);
	return ejs_rpc_init(obj, "sasl_helpers");
}

NTSTATUS ejs_init_sasl_helpers(void)
{
	ejsDefineCFunction(-1, "sasl_helpers_init", ejs_sasl_helpers_init, NULL, MPR_VAR_SCRIPT_HANDLE);
	return NT_STATUS_OK;
}
